use crate::prelude::*;

/// Gets the master password and deletes the account.
/// Although it doesn't use the master password, we get it to be sure that it's the user who used that command
async fn get_master_pass(
    bot: Throttle<Bot>,
    msg: Message,
    db: DatabaseConnection,
    dialogue: MainDialogue,
    ids: MessageIds,
    name: String,
    _: String,
) -> crate::Result<()> {
    ids.delete(&bot).await;
    dialogue.exit().await?;

    let user_id = msg.from().ok_or(NoUserInfo)?.id.0;
    Account::delete_by_id((user_id, name)).exec(&db).await?;
    bot.send_message(msg.chat.id, "The account is successfully deleted")
        .reply_markup(deletion_markup())
        .await?;
    Ok(())
}

handler!(
    get_account_name(name: String),
    "Send master password. Once you send correct master password the account is unrecoverable",
    State::GetMasterPass,
    get_master_pass
);
ask_name_handler!(
    delete,
    "Send the name of the account to delete",
    get_account_name
);
